#include <stdio.h>
#include <string.h>

int BUSY = 0;

void ShowInstructionsInfo (void)
{
    printf("\r\n");
    printf("\r\n");
    printf("************************************\r\n");
    printf("* Welcome to SAM on the PIC32 V2.0 *\r\n");
    printf("************************************\r\n");
    printf("   (not case sensitive)\r\n");
    printf("---\r\n");
    printf("$HELP      : This page!\r\n");
    printf("$TABLE     : Show PHONEME TABLE\r\n");
    printf("$DEFAULT   : Resets all values to their default values\r\n");
    printf("$STATUS    : Displays current settings\r\n");
    printf("---\r\n");
    printf("$SPEED=    : Change the speed (0-255) default=72\r\n");
    printf("$PITCH=    : Change the pitch (0-255) default=64\r\n");
    printf("$MOUTH=    : Change the mouth (0-255) default=128\r\n");
    printf("$THROAT=   : Change the throat(0-255) default=128\r\n");
    printf("---\r\n");
    printf("$TEXT      : Activate Text mode\r\n");
    printf("$PHONEME   : Activate Phoneme mode\r\n");
    printf("$SING      : Activate Sing mode\r\n");
    printf("           ( pitch,phonemes - wrong input forces reset!!!\r\n");
    printf("             Example: 96,sehehehehehehehehehey )\r\n");
    printf("---\r\n");
    printf("$DEMO1     : Speak DEMO1\r\n");
    printf("$DEMO2     : Speak DEMO2\r\n");
    printf("$DEMO3     : Sing  DEMO3\r\n");
    printf("---\r\n");
    printf("$DEBUG_ON  : Show generated phonemes");
    printf(" (...and leftover garbage from the array ;-)\r\n");
    printf("$DEBUG_OFF : Hide generated phonemes\r\n");
    printf("---\r\n");
    printf("\r\n");
}

void ShowTABLE (void)
{
    printf("\r\n");
    printf("---\r\n");
    printf("\r\n");
    printf("     VOWELS                            VOICED CONSONANTS\r\n");
    printf("IY           f(ee)t                    R        red\r\n");
    printf("IH           p(i)n                     L        allow\r\n");
    printf("EH           beg                       W        away\r\n");
    printf("AE           Sam                       W        whale\r\n");
    printf("AA           pot                       Y        you\r\n");
    printf("AH           b(u)dget                  M        Sam\r\n");
    printf("AO           t(al)k                    N        man\r\n");
    printf("OH           cone                      NX       so(ng)\r\n");
    printf("UH           book                      B        bad\r\n");
    printf("UX           l(oo)t                    D        dog\r\n");
    printf("ER           bird                      G        again\r\n");
    printf("AX           gall(o)n                  J        judge\r\n");
    printf("IX           dig(i)t                   Z        zoo\r\n");
    printf("                                       ZH       plea(s)ure\r\n");
    printf("   DIPHTHONGS                          V        seven\r\n");
    printf("EY           m(a)de                    DH       (th)en\r\n");
    printf("AY           h(igh)\r\n");
    printf("OY           boy\r\n");
    printf("AW           h(ow)                     UNVOICED CONSONANTS\r\n");
    printf("OW           slow                      S         Sam\r\n");
    printf("UW           crew                      Sh        fish\r\n");
    printf("                                       F         fish\r\n");
    printf("                                       TH        thin\r\n");
    printf(" SPECIAL PHONEMES                      P         poke\r\n");
    printf("UL           sett(le) (=AXL)           T         talk\r\r\n");
    printf("UM           astron(omy) (=AXM)        K         cake\r\n");
    printf("UN           functi(on) (=AXN)         CH        speech\r\n");
    printf("Q            kitt-en (glottal stop)    /H        a(h)ead\r\n");    
    }

void SpeakDemoText(char* str)
{
	BUSY = 1; //SAM is busy
    printf(str);
	speakText(str);
    delay_ms(200);
    BUSY = 0; //ready to receive input

}

void DemoSpeaking1(void)
{
	printf("\n\rSAM Speaking Demo 1 in progress...\n\r\n\r");
	
	SpeakDemoText("Hello everyone. My name is SAM, short for Software Automatic Mouth.");
	printf("\n\r");
	SpeakDemoText("I am ported from SAM on the P C to a P I C 3 2 using P W M for audio.");
	printf("\n\r");
	SpeakDemoText("I am so small that I can fit into embedded computers such as P I C and A V R.");
	printf("\n\r");
	SpeakDemoText("Honestly, do my voice sound better than the T T S 2 5 6 ?");
	printf("\n\r");
	SpeakDemoText("Even though obviously I still sound like a robot to you.");
	printf("\n\r");
	SpeakDemoText("Thank you for listening to me. Have a nice day. Good bye!");

	printf("\n\r\n\rSAM Speaking Demo 1 done ...\n\r");
}

void DemoSpeaking2(void)
{
	printf("\n\rSAM Speaking Demo 2 in progress...\n\r\n\r");
	
	SpeakDemoText("I can do many things, for example, counting numbers: ");
	printf("\n\r");
	SpeakDemoText("0, 1, 2, 3, 4, 5, 6, 7, 8, 9.");
	printf("\n\r");
	SpeakDemoText("And spelling letters, ");
	printf("\n\r");
	SpeakDemoText("A, B, C, D, E, F, G, H, I, J, K, L, M, ");
	printf("\n\r");	
	SpeakDemoText("N, O, P, Q, R, S, T, U, V, W, X, Y, Z.");
	printf("\n\r");	
	SpeakDemoText("Although, due to limited memory, some words may not be pronounced correctly.");
	printf("\n\r");
	SpeakDemoText("Such as: Windows, Nineteen and Recipe.");
	printf("\n\r");
	SpeakDemoText("That should be: Weendows, Nine teen, Re see pee.");
	printf("\n\r");
	SpeakDemoText("But I am still good enough to make myself understood. Or at least I hope so.");
	printf("\n\r");
	SpeakDemoText("Thank you and good bye!");

	printf("\n\r\n\rSAM Speaking Demo 2 done ...\n\r");
}

void DemoSinging(void)
{
  printf("\n\rSAM Singing Demo in progress...\n\r");

	SpeakDemoText("I will sing the National Anthem of the United States of America. ");
    printf("\n\r");
	SpeakDemoText("The Star Spangled Banner\n\r");
    BUSY = 1; //SAM is busy
	SingString(64, "ohohoh");
	SingString(76, "ohohoh");
	SingString(96, "sehehehehehehehehehey");
	SingString(76, "kaeaeaeaeaeaeaeaeaen");
	SingString(64, "yuxuxuxuxuxuxw");
	SingString(48, "siyiyiyiyiyiyiyiyiyiyiyiyiyiyiyiyiyiy");
	SingString(38, "baaaaay");
	SingString(42, "dhaaaxaxaxax");
	SingString(48, "daoaoaoaoaoaoaonz");
	SingString(76, "ererererererer");
	SingString(68, "liyiyiyiyiyiyiyiyiy");
	SingString(64, "laaaaaaaaaaaaaaaaaaaaaaaaayt");
	SingString(64, "whahahaht");
	SingString(64, "sohohuw");
	SingString(38, "praaaaaaaaaaaaaaaauwd");
	SingString(42, "liyiyiy");
	SingString(48, "wiyiyiyiyiyiyiyiyiy");
	SingString(51, "/heheheheheheheheheheheheheheheheheheyld");
	SingString(56, "aeaeaeaet");
	SingString(51, "dhaaaxaxaxax");
	SingString(48, "twaaaaaaaaaaaaaaiy");
	SingString(48, "laaaaaaaaaaaaiyts");
	SingString(64, "laeaeaeaeaeaeaeaeaest");
	SingString(76, "gliyiyiyiyiyiyiyiyiym");
	SingString(96, "mihihihihihihihihihihnx");
	SingString(64, "/huxuxuxuxuxuxuxuxuxuxwz");
	SingString(76, "braoaoaod");
	SingString(96, "straaaaaaaaaaaaiyps");
	SingString(76, "aeaeaeaeaeaeaeaeaeaend");
	SingString(64, "braaaaaaaaaaaaaaiyt");
	SingString(48, "staaaaaaaaaaaaaaaaaaaaaaaaaarz");
	SingString(38, "thruxuxw");
	SingString(42, "dhaaaxaxaxax");
	SingString(48, "pehehehehehehehehehehr");
	SingString(76, "rixixixixixixixixixixixixl");
	SingString(68, "lahahahahahahahahahs");
	SingString(64, "faaaaaaaaaaaaaaaaaaaaaaaaaaiyt");
	SingString(64, "ohohohr");
	SingString(64, "dhaaaxaxaxax");
	SingString(38, "raeaeaeaeaeaeaeaeaeaeaeaem");
	SingString(42, "paaaarts");
	SingString(48, "wiyiyiyiyiyiyiyiyiy");
	SingString(51, "waaaaaaaaaaaaaaaaaaaaaaaaaachd");
	SingString(56, "werer");
	SingString(51, "sohohw");
	SingString(48, "gaeaeaeaeaeaeaeaeaeael");
	SingString(48, "lixixixixixixixixixixixixixnt");
	SingString(64, "liyiyiyiyiyiyiyiyiy");
	SingString(76, "striyiyiyiyiyiyiyiyiym");
	SingString(96, "mihihihihihihihihihnx");
	SingString(38, "aeaeaeaeaend");
	SingString(38, "dhaaaxaxaxax");
	SingString(38, "raaaaaaaaaaaak");
	SingString(36, "kixixixixixixixixixixixts");
	SingString(32, "rehehehehehehehehehd");
	SingString(32, "gleheheheheheheheheheheheheheheherer");
	SingString(36, "dhaaaxaxaxax");
	SingString(38, "baaaamz");
	SingString(42, "bererererererst");
	SingString(38, "tihihihihihihihihihnx");
	SingString(36, "ihihihihihihihihihihn");
	SingString(36, "eheheheheheheheheheheheheheheheheheyr");
	SingString(36, "geheheheyv");
	SingString(38, "pruxuxuxuxuxuxuxuxuxuxuxuxwf");
	SingString(42, "thruxuxw");
	SingString(48, "dhaaaxaxax");
	SingString(51, "naaaaaaaaaaaaaaaaaaaaaaayiyt");
	SingString(56, "dhaeaeaeaet");
	SingString(51, "aaaaaauwr");
	SingString(48, "flaeaeaeaeaeaeaeaeaeg");
	SingString(76, "wahahahahahahahahahz");
	SingString(68, "stihihihihihihihihihl");
	SingString(64, "dhehehehehehehehehehehehehehehehehehehehr");
	SingString(64, "ohohohohohohow");
	SingString(48, "sehehehehehehehehehey");
	SingString(48, "dahahahahahahahahahz");
	SingString(48, "dhaeaeae");
	SingString(51, "aeaeaet");
	SingString(56, "staaaaaaaaaaaar");
	SingString(56, "spehehehehehehehehehiynx");
	SingString(56, "gaxaxaxaxaxaxaxaxaxaxaxaxld");
	SingString(42, "baeaeaeaeaeaeaeaeaen");
	SingString(36, "nerer");
	SingString(38, "ererer");
	SingString(42, "yeheheh");
	SingString(48, "eheheheht");
	SingString(48, "weheheheheheheheheheheh");
	SingString(51, "ehehehehehehehiyiyiyv");
	SingString(64, "ohohohr");
	SingString(64, "dhaaaxaxaxax");
	SingString(48, "laeaeaeaeaeaeaeaeaeaeaeae");
	SingString(42, "aeaeaend");
	SingString(38, "ahahahv");
	SingString(36, "dhaaaxaxaxax");
	SingString(32, "friyiyiyiyiyiyiyiyiyiyiyiyiyiyiyiyiyiy");
	SingString(48, "aeaeaend");
	SingString(42, "dhaaaxaxaxax");
	SingString(38, "/hohohohohohohohohowm");
	SingString(36, "ahahahahv");
	SingString(42, "dhaaaxaxaxaxaxaxaxaxaxaxaxaxax");
	SingString(48, "brehehehehehehehehehehiyiyiyv");
    BUSY = 0; //ready to receive input
	SpeakDemoText("Thank you for listening to me singing. Good bye!");

	printf("\n\rSAM Singing Demo done...\n\r");
    
}